# Create your views here.
from django.shortcuts import render_to_response
from django.http import HttpResponse
from django.shortcuts import get_object_or_404
from oxdjango.shortcuts import render_to_json_response
from django.core.mail import send_mail
from models import *

QUESTIONS = {
  '1problems': 'What problems do flyover and skywalk projects create?',
  '2like': 'What do you like about these projects?',
  '3stories': 'Do you have any stories about flyovers or skywalks in Mumbai or elsewhere?'
}

def geojson(request):
  features = []
  for f in Flyover.objects.all():
    features.append(f.geojson_as_dict())
  d = {
    "type": "FeatureCollection",
    "features": features
  }
  return render_to_json_response(d)
    
def index(request):
  
  return render_to_response('flyovers.html', {'questions': QUESTIONS})

def flyover(request):
  i = request.GET['id']
  f = get_object_or_404(Flyover, pk=i)
  d = {
    'name': f.name,
    'media': f.get_media()
  }
  return render_to_json_response(d)

def email_experiences(request):
  if not request.POST:
    return HttpResponse("0")
  if request.is_ajax():
    a = request.POST
    eml_txt = "Name: %s\n Email: %s\n\n" % (a['name'], a['email'],)
    for key, val in QUESTIONS.items():
      eml_txt += "%s %s" % (val, a[key],)
      eml_txt += "\n\n"
    send_mail("Vertical Urbanism Questions", eml_txt, "do-not-reply@verticalurbanism.com", ['sanjaybhangar@gmail.com', 'andrew.harris@ucl.ac.uk'])
    return HttpResponse("1")
  else:
    return HttpResponse("0")    
  

def category(request):
  cat_id = request.GET['id']
  cat_type = request.GET['type']
  cat_map = {
    'image': ImageCategory,
    'video': VideoCategory,
    'audio': AudioCategory,
    'text': TextCategory
  }
  klass = cat_map[cat_type]
  cat = klass.objects.get(pk=cat_id)
  return render_to_json_response(cat.get_dict())
  
